<?php
App::uses('BuzzSourceAppModel', 'BuzzSource.Model');

class PhotoApi extends BuzzSourceAppModel {



	public function __construct($id = false, $table = null, $ds = null) {
		parent::__construct($id, $table, $ds);

		$this->useDbConfig = 'imageApi';
		$this->dataSource = ConnectionManager::getDataSource($this->useDbConfig);
	}

	public function getTimes($applicationId, $date) {
		if (empty($applicationId) || empty($date)) {
			return false;
		}

		$result = $this->find('all', array(
			'method' => 'GetAlbumListByDate',
			'conditions' => array(
				'applicationId' => $applicationId,
				'activitydate' => $date
			)
		));

		return !empty($result['PhotoApi']['d']) ? $result['PhotoApi']['d'] : false;
	}

	public function getAlbum($albumId) {
		if (empty($albumId)) {
			return false;
		}

		$result = $this->find('all', array(
			'method' => 'GetAlbumById',
			'conditions' => array(
				'albumId' => $albumId
			)
		));

		return !empty($result['PhotoApi']['d']) ? $result['PhotoApi']['d'] : false;
	}

	public function getImage($imageId) {
		if (empty($imageId)) {
			return false;
		}

		$result = $this->find('all', array(
			'method' => 'GetImageById',
			'conditions' => array(
				'Id' => $imageId
			)
		));

		return !empty($result['PhotoApi']['d']) ? $result['PhotoApi']['d'] : false;
	}

	public function getSignedImage($imageId) {
		if (empty($imageId)) {
			return false;
		}

		$result = $this->getImage($imageId);

		if (! empty($result['LargeKey'])) {
			$image = $result['LargeKey'];
			$image = 'http://' . str_replace('_large', '', $image); // Gets round the signed URL expiring after a week...

			return $image;
		}

		return false;
	}

	public function addPhotosToSalesOrder($orderId, $customerAddress) {
		$OrderModel = ClassRegistry::init('BuzzPhotos.Order');
		$order = $OrderModel->find('first', array(
			'conditions' => array(
				'Order.id' => $orderId
			),
			'contain' => array(
				'OrderItem.ActivityGroup'
			)
		));

		$BookingApi = ClassRegistry::init('BuzzBookings.BookingApi');
		$salesRef = null;

		if (! empty($order['OrderItem'])) {
			foreach ($order['OrderItem'] as $item) {
				$result = $BookingApi->addItemToSalesOrder(
					'OrderItem',
					$item['id'],
					Configure::read('api.site_id'),
					$salesRef,
					$item['ActivityGroup']['stock_code'],
					1,
					$item['unit_price']
				);

				if (isset($result['sales_ref'])) {
					$item['sales_ref'] = $result['sales_ref'];
					$item['api_ref'] = $result['api_ref'];
					$OrderModel->OrderItem->save($item);

					$salesRef = $item['sales_ref'];
				}
			}

			$BookingApi->completeSale(
				'Order',
				$order['Order']['id'],
				$salesRef,
				$order['Order']['first_name'],
				$order['Order']['last_name'],
				$order['Order']['email'],
				$order['Order']['phone'],
				CustomerAddress::generateAddressArray($customerAddress),
				$order['Order']['total_price'],
				$OrderModel->getPaymentDetails($orderId, 'BuzzPhotos.Order')
			);
		}
	}

}